-- author: DD ModPassion
-- date: 01.05.2018
-- copyright: DD ModPassion
-- version: farming simulator 17
palletLoader = {} function palletLoader.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations) end function palletLoader:preLoad(savegame) self.setPalletState = palletLoader.setPalletState self.canBeGrabbed = palletLoader.canBeGrabbed end function palletLoader:load(savegame) self.getMeshNodes = palletLoader.getMeshNodes self.fold = false self.joint = false g_currentMission:addNodeObject(self.components[1].node, self) self.nodeId = self.components[1].node self.ballaRotonda = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.baleTypes.baleType(0)#minBaleDiameter"), 0) self.larghezza = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.storeData.specs.workingWidth"), 0) self.attachedVehicles = {} self.jointBaleGrabber = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.baleGrabber#joint")) self.palletRange = 10 end function palletLoader:postLoad(savegame) if savegame ~= nil then self.fold = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#fold"), self.fold) self.joint = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#joint"), self.joint) else self.joint = true end self:setPalletState(self.fold, self.joint, true) end function palletLoader:getSaveAttributesAndNodes(nodeIdent) local attributes = 'fold="'..tostring(self.fold)..'" joint="'..tostring(self.joint)..'"' return attributes, nil end function palletLoader.readStream(self, streamId, connection) if connection:getIsServer() then local isFold = streamReadBool(streamId) local isJoint = streamReadBool(streamId) self:setPalletState(isFold, isJoint, true) end end function palletLoader.writeStream(self, streamId, connection) if not connection:getIsServer() then streamWriteBool(streamId, self.fold) streamWriteBool(streamId, self.joint) end end function palletLoader:delete() if self.isServer then for index, vehicle in pairs(self.attachedVehicles) do removeJoint(vehicle.JointIndex) delete(vehicle.AT) vehicle.JointIndex = nil end end self.attachedVehicles = nil self.attachedVehicles = {} end function palletLoader:mouseEvent(posX, posY, isDown, isUp, button) end function palletLoader:keyEvent(unicode, sym, modifier, isDown) end function palletLoader:update(dt) if self.firstTimeRun and self.joint == true and table.getn(self.attachedVehicles) == 0 then self:setPalletState(self.fold, self.joint) end if self.isClient then if g_currentMission.player ~= nil and g_currentMission.player.isEntered then local gx, gy, gz = getWorldTranslation(g_currentMission.player.rootNode) local mx, my, mz = getWorldTranslation(self.components[1].node) local tx, ty, tz = getWorldTranslation(self.components[2].node) if Utils.vector3Length(gx-tx, gy-ty, gz-tz) < 4 and Utils.vector3Length(tx-mx, ty-my, tz-mz) > self.palletRange then if self.emptyState == baleLoad.CHANGE_GRAB_DROP_BALE then if self.ballaRotonda > 0 then g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("finance_other").." "..g_i18n:getText("category_pallets")..": "..g_i18n:getText("warning_noMoreFreeCapacity"), g_i18n:getText("fillType_roundBale"))) else g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("finance_other").." "..g_i18n:getText("category_pallets")..": "..g_i18n:getText("warning_noMoreFreeCapacity"), g_i18n:getText("fillType_squareBale"))) end end if not self.joint then if self.ballaRotonda > 0 then g_currentMission:addExtraPrintText(g_i18n:getText("finance_harvestIncome")..": "..g_i18n:getText("fillType_roundBale").." - "..g_i18n:getText("category_pallets")..": "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) else g_currentMission:addExtraPrintText(g_i18n:getText("finance_harvestIncome")..": "..g_i18n:getText("fillType_squareBale").." - "..g_i18n:getText("category_pallets")..": "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) end end if self.fold then if InputBinding.hasEvent(self.workTransportButton) then g_client:getServerConnection():sendEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_BUTTON_WORK_TRANSPORT)) end elseif not self.joint and not g_currentMission.player.isCarryingObject then g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("finance_other").." "..g_i18n:getText("category_pallets")..": "..g_i18n:getText("button_confirm").." "..g_i18n:getText("action_baleloaderOperatingPosition"))) end if self.emptyState == baleLoad.EMPTY_NONE and self.fold then if self.grabberMoveState == nil then if self.isInWorkPosition then g_currentMission:addHelpButtonText(g_i18n:getText("action_siloStopFilling"), self.workTransportButton, nil, GS_PRIO_NORMAL) if self.fillUnits[1].fillLevel == self.fillUnits[1].capacity then g_client:getServerConnection():sendEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_BUTTON_WORK_TRANSPORT)) end else g_currentMission:addHelpButtonText(g_i18n:getText("action_siloStartFilling"), self.workTransportButton, nil, GS_PRIO_NORMAL) end end end end if Utils.vector3Length(gx-mx, gy-my, gz-mz) < 4 and Utils.vector3Length(tx-mx, ty-my, tz-mz) > self.palletRange then if self.emptyState == baleLoad.CHANGE_GRAB_DROP_BALE then if self.ballaRotonda > 0 then g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("warning_noMoreFreeCapacity"), g_i18n:getText("fillType_roundBale"))) else g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("warning_noMoreFreeCapacity"), g_i18n:getText("fillType_squareBale"))) end end if self.ballaRotonda > 0 then g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_roundBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) else g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_squareBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) end if not self.isInWorkPosition and not self.joint and self.fillUnits[1].fillLevel == 0 then if InputBinding.hasEvent(InputBinding.TOGGLE_COVER) then self:setPalletState(not self.fold, self.joint) end if self.fold then g_currentMission:addHelpButtonText(g_i18n:getText(self.textTransportPosition), InputBinding.TOGGLE_COVER, nil, GS_PRIO_NORMAL) else g_currentMission:addHelpButtonText(g_i18n:getText(self.textOperatingPosition), InputBinding.TOGGLE_COVER, nil, GS_PRIO_NORMAL) end elseif self.fillUnits[1].fillLevel == 0 and not self.joint and self.emptyState ~= baleLoad.CHANGE_GRAB_DROP_BALE and not g_currentMission.player.isCarryingObject then g_currentMission:showBlinkingWarning(string.format(g_i18n:getText("finance_other").." "..g_i18n:getText("category_pallets")..": "..g_i18n:getText("action_siloStopFilling"))) end if self.fold then if InputBinding.hasEvent(self.emptyButton) then g_client:getServerConnection():sendEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_BUTTON_EMPTY)) elseif InputBinding.hasEvent(self.emptyAbortButton) then g_client:getServerConnection():sendEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_BUTTON_EMPTY_ABORT)) end if self.emptyState == baleLoad.EMPTY_NONE then if baleLoad.getAllowsStartUnloading(self) then g_currentMission:addHelpButtonText(g_i18n:getText(self.textUnload), self.emptyButton, nil, GS_PRIO_NORMAL) end else if self.emptyState >= baleLoad.EMPTY_TO_WORK and self.emptyState <= baleLoad.EMPTY_ROTATE2 then g_currentMission:addExtraPrintText(g_i18n:getText(self.textTilting)) elseif self.emptyState == baleLoad.EMPTY_CANCEL or self.emptyState == baleLoad.EMPTY_SINK then g_currentMission:addExtraPrintText(g_i18n:getText(self.textLowering)) elseif self.emptyState == baleLoad.EMPTY_WAIT_TO_DROP then g_currentMission:addHelpButtonText(g_i18n:getText(self.textUnloadHere), self.emptyButton, nil, GS_PRIO_NORMAL) g_currentMission:addHelpButtonText(g_i18n:getText(self.textAbortUnloading), self.emptyAbortButton, nil, GS_PRIO_NORMAL) elseif self.emptyState == baleLoad.EMPTY_WAIT_TO_SINK then g_currentMission:addHelpButtonText(g_i18n:getText(self.textLowerPlattform), self.emptyButton, nil, GS_PRIO_NORMAL) elseif self.emptyState == baleLoad.EMPTY_WAIT_TO_REDO then g_currentMission:addHelpButtonText(g_i18n:getText(self.textUnload), self.emptyButton, nil, GS_PRIO_NORMAL) end end end end if Utils.vector3Length(gx-mx, gy-my, gz-mz) < 4 or Utils.vector3Length(gx-tx, gy-ty, gz-tz) < 4 then if not self.fold then if InputBinding.hasEvent(InputBinding.ATTACH) then self:setPalletState(self.fold, not self.joint) end if self.joint then if self.ballaRotonda > 0 then g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_roundBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) else g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_squareBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) end g_currentMission:addHelpButtonText(g_i18n:getText("action_detach").." "..g_i18n:getText("category_pallets"), InputBinding.ATTACH, nil, GS_PRIO_NORMAL) else g_currentMission:addHelpButtonText(g_i18n:getText("action_attach").." "..g_i18n:getText("category_pallets"), InputBinding.ATTACH, nil, GS_PRIO_NORMAL) local distanza = Utils.vector3Length(tx-mx, ty-my, tz-mz) if self.palletRange - Utils.vector3Length(tx-mx, ty-my, tz-mz) > 0 then if self.ballaRotonda > 0 then g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_roundBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) else g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_squareBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) end g_currentMission:addExtraPrintText(g_i18n:getText("ui_movePlaceable").." > "..self.palletRange.." "..g_i18n:getText("unit_miles")..":    "..g_i18n:getText("category_pallets").."      <-   "..string.format("%1.2f ", distanza).." "..g_i18n:getText("unit_miles").."  ->      "..g_i18n:getText("category_pallets")) else g_currentMission:addExtraPrintText(g_i18n:getText("ui_movePlaceable").." > "..self.palletRange.." "..g_i18n:getText("unit_miles")..":    "..g_i18n:getText("category_pallets").." "..g_i18n:getText("button_ok").."  <-  > "..self.palletRange.." "..g_i18n:getText("unit_miles").."  ->  "..g_i18n:getText("category_pallets").." "..g_i18n:getText("button_ok")) end end else local distanza = Utils.vector3Length(tx-mx, ty-my, tz-mz) if self.palletRange - Utils.vector3Length(tx-mx, ty-my, tz-mz) > 0 then if self.ballaRotonda > 0 then g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_roundBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) else g_currentMission:addExtraPrintText(g_i18n:getText("shop_configuration")..": "..g_i18n:getText("fillType_squareBale").." - "..g_i18n:getText("shop_workingWidth").." "..string.format("%1.2f", self.larghezza)..(" ")..g_i18n:getText("unit_miles")) end g_currentMission:addExtraPrintText(g_i18n:getText("ui_movePlaceable").." > "..self.palletRange.." "..g_i18n:getText("unit_miles")..":    "..g_i18n:getText("category_pallets").."      <-   "..string.format("%1.2f ", distanza).." "..g_i18n:getText("unit_miles").."  ->      "..g_i18n:getText("category_pallets")) else g_currentMission:addExtraPrintText(g_i18n:getText("ui_movePlaceable").." > "..self.palletRange.." "..g_i18n:getText("unit_miles")..":    "..g_i18n:getText("category_pallets").." "..g_i18n:getText("button_ok").."  <-  > "..self.palletRange.." "..g_i18n:getText("unit_miles").."  ->  "..g_i18n:getText("category_pallets").." "..g_i18n:getText("button_ok")) end end end end if self.grabberIsMoving then if not self:getIsAnimationPlaying("baleGrabberTransportToWork") then self.grabberIsMoving = false end end self.allowGrabbing = false if self.isInWorkPosition and not self.grabberIsMoving and self.grabberMoveState == nil and self.startBalePlace.count < self.startBalePlace.numOfPlaces and self.frontBalePusherDirection == 0 and self.rotatePlatformDirection == 0 and (not self.alwaysMoveBalePlaces or not self:getIsAnimationPlaying("moveBalePlaces")) and self.emptyState == baleLoad.EMPTY_NONE and self:getFillLevel(self.baleDummyFillType) < self:getCapacity(self.baleDummyFillType) and self.fold then self.allowGrabbing = true end if self.allowGrabbing then if self.baleGrabber.grabNode ~= nil and self.baleGrabber.currentBale == nil then local nearestBale, nearestBaleType = baleLoad.getBaleInRange(self, self.baleGrabber.grabNode) if nearestBale ~= nil then if self.isServer then self:pickupBale(nearestBale, nearestBaleType) end end end end if self.isServer then if self.grabberMoveState ~= nil then if self.grabberMoveState == baleLoad.GRAB_MOVE_UP then if not self:getIsAnimationPlaying("baleGrabberWorkToDrop") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_GRAB_MOVE_UP), true, nil, self) end elseif self.grabberMoveState == baleLoad.GRAB_DROP_BALE then if not self:getIsAnimationPlaying(self.currentBaleGrabberDropBaleAnimName) then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_GRAB_DROP_BALE), true, nil, self) end elseif self.grabberMoveState == baleLoad.GRAB_MOVE_DOWN then if not self:getIsAnimationPlaying("baleGrabberWorkToDrop") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_GRAB_MOVE_DOWN), true, nil, self) end end end if self.frontBalePusherDirection ~= 0 then if not self:getIsAnimationPlaying("frontBalePusher") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_FRONT_PUSHER), true, nil, self) end end if self.rotatePlatformDirection ~= 0 then local name = self.rotatePlatformAnimName if self.rotatePlatformDirection < 0 then name = self.rotatePlatformBackAnimName end if not self:getIsAnimationPlaying(name) and not self:getIsAnimationPlaying("moveBalePlacesExtrasOnce") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_ROTATE_PLATFORM), true, nil, self) end end if self.emptyState ~= baleLoad.EMPTY_NONE then if self.emptyState == baleLoad.EMPTY_TO_WORK then if not self:getIsAnimationPlaying("baleGrabberTransportToWork") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_ROTATE_PLATFORM), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_ROTATE_PLATFORM then if not self:getIsAnimationPlaying(self.rotatePlatformEmptyAnimName) then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_ROTATE1), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_ROTATE1 then if not self:getIsAnimationPlaying("emptyRotate") and not self:getIsAnimationPlaying("moveBalePlacesToEmpty") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_CLOSE_GRIPPERS), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_CLOSE_GRIPPERS then if not self:getIsAnimationPlaying("closeGrippers") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_HIDE_PUSHER1), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_HIDE_PUSHER1 then if not self:getIsAnimationPlaying("emptyHidePusher1") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_HIDE_PUSHER2), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_HIDE_PUSHER2 then if self:getAnimationTime("moveBalePusherToEmpty") < 0.7 or not self:getIsAnimationPlaying("moveBalePusherToEmpty") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_ROTATE2), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_ROTATE2 then if not self:getIsAnimationPlaying("emptyRotate") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_WAIT_TO_DROP), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_SINK then if not self:getIsAnimationPlaying("emptyRotate") and not self:getIsAnimationPlaying("moveBalePlacesToEmpty") and not self:getIsAnimationPlaying("emptyHidePusher1") and not self:getIsAnimationPlaying(self.rotatePlatformEmptyAnimName) then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_STATE_NIL), true, nil, self) end elseif self.emptyState == baleLoad.EMPTY_CANCEL then if not self:getIsAnimationPlaying("emptyRotate") then g_server:broadcastEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_EMPTY_WAIT_TO_REDO), true, nil, self) end end end if self.fillUnits[1].fillLevel == self.fillUnits[1].capacity then g_client:getServerConnection():sendEvent(baleLoadStateEvent:new(self, baleLoad.CHANGE_BUTTON_EMPTY)) end end end end function palletLoader:draw() end function palletLoader:setPalletState(isFold, isJoint, noEventSend) setPalletStateEvent.sendEvent(self, isFold, isJoint, noEventSend) if isFold then self:playAnimation("folding", -1, self:getAnimationTime("folding"), true) else self:playAnimation("folding", 1, self:getAnimationTime("folding"), true) end if isJoint then if g_currentMission.player ~= nil then local baleGrabber = self.components[2].node local attachedVehicle = {} attachedVehicle.object = baleGrabber attachedVehicle.AT = createTransformGroup("AT") link(self.rootNode, attachedVehicle.AT) local constr = JointConstructor:new() constr:setActors(self.rootNode, baleGrabber) constr:setJointTransforms(self.jointBaleGrabber, baleGrabber) for i=1, 3 do constr:setTranslationLimit(i-1, true, 0, 0) constr:setRotationLimit(i-1,0,0) end attachedVehicle.JointIndex = constr:finalize() table.insert(self.attachedVehicles, attachedVehicle) end self:playAnimation("attach", 1, self:getAnimationTime("attach"), true) else for index, vehicle in pairs(self.attachedVehicles) do removeJoint(vehicle.JointIndex) delete(vehicle.AT) vehicle.JointIndex = nil end self.attachedVehicles = nil self.attachedVehicles = {} self:playAnimation("attach", -1, self:getAnimationTime("attach"), true) end self.fold = isFold self.joint = isJoint end function palletLoader:getMeshNodes() local nodes = {} table.insert(nodes, self.nodeId) return nodes end function palletLoader:canBeGrabbed() return true end function Player:pickUpObjectRaycastCallback(hitObjectId, x, y, z, distance) if distance > 0.5 and distance <= Player.MAX_PICKABLE_OBJECT_DISTANCE then if hitObjectId ~= g_currentMission.terrainDetailId and Player.PICKED_UP_OBJECTS[hitObjectId] ~= true then if getRigidBodyType(hitObjectId) == "Dynamic" then local object = g_currentMission:getNodeObject(hitObjectId) if (object ~= nil and object.dynamicMountObject == nil) or g_currentMission.nodeToVehicle[hitObjectId] == nil or (g_currentMission.nodeToVehicle[hitObjectId].canBeGrabbed ~= nil and g_currentMission.nodeToVehicle[hitObjectId]:canBeGrabbed()) then self.lastFoundObject = hitObjectId self.lastFoundObjectMass = getMass(hitObjectId) self.lastFoundObjectHitPoint = {x, y, z} return false end end end end return true end setPalletStateEvent = {} setPalletStateEvent_mt = Class(setPalletStateEvent, Event) InitEventClass(setPalletStateEvent, "setPalletStateEvent") function setPalletStateEvent:emptyNew() local self = Event:new(setPalletStateEvent_mt) self.className="setPalletStateEvent" return self end function setPalletStateEvent:new(object, isFold, isJoint) local self = setPalletStateEvent:emptyNew() self.object = object self.isFold = isFold self.isJoint = isJoint return self end function setPalletStateEvent:readStream(streamId, connection) self.object = readNetworkNodeObject(streamId) self.isFold = streamReadBool(streamId) self.isJoint = streamReadBool(streamId) self:run(connection) end function setPalletStateEvent:writeStream(streamId, connection) writeNetworkNodeObject(streamId, self.object) streamWriteBool(streamId, self.isFold) streamWriteBool(streamId, self.isJoint) end function setPalletStateEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.object) end if self.object ~= nil then self.object:setPalletState(self.isFold, self.isJoint, true) end end function setPalletStateEvent.sendEvent(vehicle, isFold, isJoint, noEventSend) if vehicle.fold ~= isFold or vehicle.joint ~= isJoint then if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(setPalletStateEvent:new(vehicle, isFold, isJoint), nil, nil, vehicle) else g_client:getServerConnection():sendEvent(setPalletStateEvent:new(vehicle, isFold, isJoint)) end end end end